var moment = require('moment')
var ws = require('ws.js')
var Http = ws.Http
var Addr = ws.Addr
var to_json = require('xmljson').to_json;
var parseString = require('xml2js').parseString;
var qs = require('qs');
var request = require('client-request')

function Client(options) {
  this.options   =  options || {}
  this.url = this.options.url
  this.consultaGirosRangoFechaALL = this.options.consultaGirosRangoFechaALL //action
  this.consultaGirosRangoFechaALLV2 = this.options.consultaGirosRangoFechaALLV2 //action
}


Client.prototype._request = function(ctx, callback) {
  var handlers =  [new Http()]
  ws.send(handlers, ctx, function(result) {

    result = result.response.substr(288, result.response.length)
    result = result.substr(0,result.length-86)
    result = result.replace(/<return xsi:type="responseConsultaDetalleGiroFechaDTO">/gi,'<return>')
    result = '<giros>' + result + '</giros>'
    parseString(result , function (err, resultJSON) {
        if(err) return callback(err,null)
        callback(null,JSON.stringify(resultJSON))
    });

  })
}

Client.prototype._request_v2 = function(ctx, callback) {
  var handlers =  [new Http()]
  ws.send(handlers, ctx, function(result) {
    
    result = result.response.substr(293, result.response.length)
    result = result.substr(0,result.length-91)
    result = result.replace(/<return xsi:type="responseConsultaMovimientosFechaDTO">/gi,'<return>')
    result = '<giros>' + result + '</giros>'
    parseString(result , function (err, resultJSON) {
        if(err) return callback(err,null)
        callback(null,JSON.stringify(resultJSON))
    });

  })
}



Client.prototype.consultaGiros_All = function(fechaFin,fechaInicio,callback) {
           
                ctx =  { 
                  request:` <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:gir="http://giros.services.siga.gana.com.co/">
                            <soapenv:Header/>
                            <soapenv:Body>
                            <gir:consultaDetallesGiroPorFiltroFecha>
                            <requestConsultaDetalleGirosFechaDTO>
                            <fechaFin>${fechaFin}</fechaFin>
                            <fechaInicio>${fechaInicio}</fechaInicio>
                            <idTipoSolicitud>2</idTipoSolicitud>
                            </requestConsultaDetalleGirosFechaDTO>
                            </gir:consultaDetallesGiroPorFiltroFecha>
                            </soapenv:Body>
                            </soapenv:Envelope>`
                            , url: this.url
                            , action: this.consultaGirosRangoFechaALL
                            , contentType: "text/xml"
                          }
                              
                               this._request(ctx, callback)
                             }


 Client.prototype.consultaGiros_All_V2 = function(fechaFin,fechaInicio,callback) {
   ctx =  { 
                                request:`<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:gir="http://giros.services.siga.gana.com.co/">
                                         <soapenv:Header/>
                                         <soapenv:Body>
                                         <gir:consultarMovimientosGirosPorFiltroFecha>
                                         <requestConsultaMovimientosFechaDTO>
                                         <fechaFin>${fechaFin}</fechaFin>
                                         <fechaInicio>${fechaInicio}</fechaInicio>
                                         <idTipoSolicitud>2</idTipoSolicitud>
                                         </requestConsultaMovimientosFechaDTO>
                                         </gir:consultarMovimientosGirosPorFiltroFecha>
                                         </soapenv:Body>
                                         </soapenv:Envelope>`
                                          , url: this.url
                                          , action: this.consultaGirosRangoFechaALLV2
                                          , contentType: "text/xml"
                                        }
                                            
                                             this._request_v2 (ctx, callback)
                                           }                             
                                                        
module.exports = Client
